﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using HeuristicLab.Services.Optimization.Web.Models;
using HeuristicLab.Services.Optimization.Web.Helpers;
using System.Web.Security;
using HeuristicLab.Services.Optimization.ControllerService.Model;

namespace HeuristicLab.Services.Optimization.Web.Controllers
{
  public class StatusController : Controller {
    private ControllerServiceHelper ControllerService {
      get {
        var helper = new ControllerServiceHelper(Session["pw"] as string);
        if (!helper.Valid) {
          Response.Redirect("/Account/Logon?ReturnUrl=%2fStatus");
        }
        return helper;
      }
    }

    //
    // GET: /Status/

    public ActionResult Index() {
      var statModel = ControllerService.withControllerService<StatusModel>((service) => {
        var model = new StatusModel();
        User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
        model.Jobs = service.GetJobs(u).ToList();
        return model;
      });
      return View(statModel);
    }

    [HttpGet]
    public JsonResult GetTasks(string jobId) {      
      var job = ControllerService.withControllerService<Job>((service) => {        
        User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };        
        return service.GetTasks(u, jobId);
      });

      return Json(job, JsonRequestBehavior.AllowGet);
    }

    [HttpGet]
    public JsonResult GetTaskData(string jobId, string taskId) {
      var t1 = ControllerService.withControllerService<Task>((service) => {
        User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
        return service.GetTaskData(u, jobId, taskId);
      });
      return Json(t1, JsonRequestBehavior.AllowGet);
    }
  }
}
